/*
kurs:
- ETE7013L Optymalizacja procesow dyskretnych

termin:
- CZW/P 09:15

autorzy:
- Dominik Chalupczynski
- Stanislaw Kozuchowicz
- ukasz Fajdek
*/

#include <iostream.h>
#include <conio.h>

//------------------------------------------------------------------------------------------------------------------------

int tab_perm [362880][9];  //tablica przechowujaca zbior wszystkich permutacji
int w = 0, k, n;           //zmienne odpowiadajace za wiersz, kolumne, i dugosc permutacji

//------------------------------------------------------------------------------------------------------------------------

void drukuj(const int *v, const int rozm)    //funkcja wyswietlajaca, i zapisujaca zbior permutacji
{
  if (v != 0)
  {
    for (int k = 0; k < rozm; k++)
    {
      //cout << v[k] << " " ;
      tab_perm[w][k] = v[k];
    }
    //cout << endl;
    w++;
  }

}

//------------------------------------------------------------------------------------------------------------------------

void permutacje(int *v, const int start, int n)         //funkcja generujaca permutacje
{

  if (start == n-1)
  {
    drukuj(v, n);
  }
  else
  {
    for (int i = start; i < n; i++)
    {
      int tmp = v[i];

      v[i] = v[start];
      v[start] = tmp;
      permutacje(v, start+1, n);
      v[start] = v[i];
      v[i] = tmp;
    }
  }
}

//------------------------------------------------------------------------------------------------------------------------

unsigned long int silnia (int s)        //jak sama nazwa wskazuje funkcja obliczajaca silnie
  {
  if (s == 0)
    return 1;
  else
    return s*silnia(s-1);
  }

//------------------------------------------------------------------------------------------------------------------------

int maks(int T)
{
if (T > 0)
  return T;
else
  return 0;
}

//------------------------------------------------------------------------------------------------------------------------

main()
{
  int v[] = {0, 1, 2, 3, 4, 5, 6, 7, 8};        //wektor pomocniczy
  int t[9];                                     //tablica przechowujaca czasy wkonywania poszczegolonych zadan
  int w[9];                                     //tablica przechowujaca wagi poszczegolnych zadan
  int d[9];                                     //tablica przechowujaca deadline`y poszczegolnych zadan
  long int c = 0;                               //zmienna przechowujaca czas zakonczenia zadania
  long int T;                                   //zmienna przechowujaca czas opuznienia zadania
  long int F = 0;                               //zmienna przechowujaca wartosc funkcji celu
  long int F_opt = 1000000;                     //zmienna przechowujaca optymalna wartosc funkcji celu
  long int perm_opt;                            //zmienna przechowujaca numer wiersza tablicy tab_perm,
                                                //w ktorej znajduje sie permutacja o optymalnej wratosci funkcji celu

//------------------------------------------------------------------------------------------------------------------------

  clrscr();
  cout << "Prosze wprowadzic liczbe zadan:";
  cin >> n ;
  cout << endl ;

  for (int l = 0; l<n; l++)
  {
    cout << "Prosze wprowadzic czas wykonania zadania nr." << l + 1 << ": ";
    cin >> t[l];
    cout <<endl;

    cout << "Prosze wprowadzic wage zadnia nr." << l + 1 << ": ";
    cin >> w[l];
    cout <<endl;

    cout << "Prosze wprowadzic deadline zadania nr." << l + 1 << ": ";
    cin >> d[l];
    cout <<endl;

    clrscr();
  }

  clrscr();

  for(int m=0; m<n; m++)
  {
    cout << "Zadanie nr." << m+1 << ": " << endl;
    cout << "     - czas wykonania t" << m + 1 << ": " << t[m] << endl;
    cout << "     - waga w" << m + 1 << ": " << w[m] << endl;
    cout << "     - deadline d" << m + 1 << ": " << d[m] << endl;
    cout << endl;
  }

//------------------------------------------------------------------------------------------------------------------------

  permutacje(v, 0, n);

  for (int a = 0; a < silnia(n); a++)
  {
    for (int b = 0; b < n; b++)
    {
      c = c + t[tab_perm[a][b]];
      T = maks(c - d[tab_perm[a][b]]);
      F = F + T * w[tab_perm[a][b]];
      //cout << "t[" << tab_perm[a][b]<< "]= " << t[tab_perm[a][b]] << "      " << "c[" << b << "]= " << c <<"      " << "T[" << tab_perm[a][b] << "]= " << T << "      " << "F[" << tab_perm[a][b] << "]= " << F << endl;
    }
    //cout << "F" << a << "= " << F << endl;
    if (F_opt > F)
    {
      F_opt = F;
      perm_opt =a ;
    }
    c = 0;
    F = 0;
  }
  cout << endl;
  cout << "Optymalna kolejnosc wykonania zadan to:" << endl;
  for (int h = 0; h < n; h++)
  {
    cout << tab_perm[perm_opt][h] + 1 << "  " ;
  }
getch();
}

//------------------------------------------------------------------------------------------------------------------------
